part of katana_routing;

/// Container for storing special classes in the WidgetRef of the page.
abstract class PageValueContainer<T> {
  PageValueContainer(this.value) {
    initState();
  }

  /// True if the object has already been destroyed.
  bool get disposed => _disposed;
  bool _disposed = false;

  /// The value to store in the container.
  T value;

  /// Called when the container is created.
  @protected
  @mustCallSuper
  void initState() {}

  /// Called when the page is Disposed.
  @mustCallSuper
  void dispose() {
    _disposed = true;
  }
}
